package handler

import (
	"context"
	"net/http"

	"git.unistack.org/unistack-org/pkgdash/internal/models"
	pb "git.unistack.org/unistack-org/pkgdash/proto"
	httpsrv "go.unistack.org/micro-server-http/v4"
	"go.unistack.org/micro/v4/logger"
)

func (h *Handler) PackageModules(ctx context.Context, req *pb.PackageModulesReq, rsp *pb.PackageModulesRsp) error {
	logger.Debug(ctx, "PackageModules handler start")

	modules, err := h.store.PackageModules(ctx, req)
	if err != nil {
		logger.Error(ctx, "error db response: %v", err)
		httpsrv.SetRspCode(ctx, http.StatusInternalServerError)
		return httpsrv.SetError(NewInternalError(err))
	}

	for _, mod := range modules {
		rsp.Modules = append(rsp.Modules, models.NewModule(mod))
	}
	logger.Debug(ctx, "PackagesModules handler stop")
	return nil
}
